import java.util.ArrayList;
import java.util.Random;

import com.cycling74.max.*;
import com.cycling74.jitter.*;
import com.cycling74.max.Atom;
import com.cycling74.max.MaxObject;

public class render4 extends MaxObject
{
	//private class declaration
	private class Ball {
		public double x,y,z,scale;
		JitterObject ball;
		public Ball(JitterObject _ball) {
			this.ball = _ball;
			this.ball.setAttr("enable", 0);
			this.ball.setAttr("shape", "circle");
			this.ball.setAttr("displaylist", 1);
		}
		public void setPos(double _x, double _y, double _z) {
			x = _x;  y = _y;  z = _z;
			this.ball.setAttr("position",new float[] {(float)x, (float)y, (float)0});              // THIS KILLS ME?
		}
		public void setScale(double _scale) {
			scale = _scale;
			this.ball.setAttr("scale",new float[] {(float)scale, (float)scale, (float)scale});
		}
	}
	
	public double randomLong(double cur, long _seed) {
		//long x = System.nanoTime();
		long x = (long) (_seed+cur);
		x ^= (x << 21);
		x ^= (x >>> 35);
		x ^= (x << 4);
		return (double)x/(double)150000000000000000000.0;
	}
	
	
	// static variable declaration
	ArrayList<Ball> balls;
	static int COUNT = 50;
	int counter = 0;
	static int maxcounter = 20000;
	static double X_RANGE = 1.8;
	static double Y_RANGE = 1.5;
	private long seed;
	private boolean hasInit = false;
	private boolean randomMove = false;
	Random r = new Random();
	
    private static final String[] INLET_ASSIST = { "inlet 1 help" };
    private static final String[] OUTLET_ASSIST = { "outlet 1 help" };
    
    public render4(Atom[] atoms) 	{    			
    	hasInit=false;
    	balls = new ArrayList<Ball>();
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL,DataTypes.ALL,DataTypes.ALL});
		
		setInletAssist(INLET_ASSIST);
		setOutletAssist(OUTLET_ASSIST);		
		
		for (int i=0; i<COUNT; i++) {
			Ball b = new Ball(new JitterObject("jit.gl.gridshape",new Atom[]{Atom.newAtom("bobby")}));
	        b.ball.setAttr("shape", "circle");
			//mycircle.setAttr("lighting_enable",1);
			b.setPos(Math.random()*X_RANGE-(X_RANGE/2), Math.random()*Y_RANGE-(Y_RANGE/2), 0);
			b.setScale(.03);
			b.ball.setAttr("smooth_shading",0);
			b.ball.setAttr("enable",1);
			balls.add(i, b);
		}
		outlet(0,"loaded "+COUNT+" circles");
		hasInit=true;
	}
    
    public void bang() {    	
    	if (!hasInit)
    		return;    	
    	long startTime = System.nanoTime();
    	counter++;
    	//if (counter==1)
    		//System.gc();
    	seed = System.nanoTime();
    	for (int i=0; i<COUNT; i++) {
    		Ball ball = balls.get(i);
        	if (randomMove) {
        		//ball.setPos(ball.x+=(randomLong(ball.x, seed)-.5)/1000, ball.y+=(randomLong(ball.y, seed)-.5)/1000, ball.z);
        		//ball.setPos(ball.x+.1, ball.y+.1, ball.z);
        		ball.ball.setAttr("position",new float[] {(float)(ball.x+=.0001), (float)(ball.y+=.0001), (float)0});    // THIS KILLS ME?
        	}
    		outlet(0,"circle "+i+" "+ball.x+","+ball.y+","+ball.z);
    		//outlet(2,randomLong(ball.x,seed));
    	}
    	//sketch.setAttr("position",handle.getAttr("position"));
		//sketch.setAttr("rotate",handle.getAttr("rotate"));
		//render.send("erase");
		//render.send("drawclients");
		//render.send("swap");
    	outlet(1,(System.nanoTime() - startTime)/1000000+" ms");
    	if (counter==maxcounter)
    		counter=0;
    }
    
    public void kill() {
    	int i=COUNT;
    	while (i>0) {
    		JitterObject temp = balls.remove(0).ball;
    		temp.setAttr("enable", 0);
    		temp.freePeer();
    		i--;
    	}
    	//System.gc();
    }
    
    public void enableRandom() {randomMove=true; }
    public void disableRandom(){randomMove=false;}
    
    public void inlet(int i) {
	/* empty */
    }
    
    public void inlet(float f) {
	/* empty */
    }
    
    public void list(Atom[] atoms) {
	/* empty */
    }
    
    public void notifyDeleted() {
    	outlet(0,"cleaning up");     //ensures cleaning
    	int i=COUNT;
    	while (i>0) {
    		JitterObject temp = balls.remove(0).ball;
    		temp.setAttr("enable", 0);
    		temp.freePeer();
    		i--;
    	}
    	//System.gc();    	
    }
}


